package com.qgs.dc.influx.controller;

import com.influxdb.client.domain.WritePrecision;
import com.influxdb.client.write.Point;
import com.influxdb.query.FluxRecord;
import com.influxdb.query.FluxTable;
import com.qgs.dc.influx.config.InfluxClient;
import com.qgs.dc.influx.param.*;
import com.qgs.dc.influx.template.Event;
import com.qgs.dc.influx.template.EventString;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.time.Instant;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.qgs.dc.influx.Main.getDate;
import static com.qgs.dc.influx.Main.getDateAfter;

@RestController
@RequestMapping("/influx")
public class InfluxDemoController {
    private static final Logger logger = LoggerFactory.getLogger(InfluxDemoController.class);



//       try (WriteApi writeApi = influxDBClient.makeWriteApi()) {
//            Temperature temperature = new Temperature();
//            temperature.setLocation("east");
//            temperature.setValue(106.2D);
//            temperature.setTime(Instant.now());
//            writeApi.writeMeasurement(WritePrecision.NS,temperature);
//        }
//
//        try (WriteApi writeApi = influxDBClient.makeWriteApi()) {
//            Point point = Point.measurement("temperature")
//                    .addTag("location","south")
//                    .addTag("owner","wxm")
//                    .addField("wxm",230.8);
//            writeApi.writePoint(point);
//        }


    @PostMapping("/insertBatch")
    public void insertBatch(@RequestBody InsertParam insertParam) throws InterruptedException {
        InfluxClient.Client.batchInsert(insertParam.getList(),insertParam.getMeasurement());
    }

    public static void main(String[] args) throws InterruptedException {
//        InsertParamString insertParam = new InsertParamString();
//        List<EventString> list = new ArrayList<>();
//        EventString event = new EventString();
//        event.setTransationId("S1");
//        event.setTime(new Date().toInstant());
//        event.setArgName("A1");
//        event.setArgValue("v1");
//
//        EventString event2 = new EventString();
//        event2.setTransationId("S1");
//        event2.setTime(new Date().toInstant());
//        event2.setArgName("A2");
//        event2.setArgValue("v2");
//        list.add(event);
//        list.add(event2);
//        insertParam.setList(list);
//        insertParam.setMeasurement("CSCSCSCCS");
//        InfluxClient.Client.batchInsertString(insertParam.getList(),insertParam.getMeasurement());
        InsertParam insertParam = new InsertParam();
        List<Event> list = new ArrayList<>();
        Event event = new Event();
        event.setTransationId("S1");
        event.setTime(new Date().toInstant());
        event.setArgName("A1");
        event.setArgValue((double)3);

        Thread.sleep(100);

        Event event2 = new Event();
        event2.setTransationId("S1");
        event2.setTime(new Date().toInstant());
        event2.setArgName("A2");
        event2.setArgValue((double)4);
        list.add(event);
        list.add(event2);

        insertParam.setList(list);
        insertParam.setMeasurement("CSCSCSCCS");
        InfluxClient.Client.batchInsert(insertParam.getList(),insertParam.getMeasurement());
    }


    @PostMapping("/insertBatchString")
    public void insertBatchString(@RequestBody InsertParamString insertParam) throws InterruptedException {
        InfluxClient.Client.batchInsertString(insertParam.getList(),insertParam.getMeasurement());
    }

    public Point insert(Event event, String measurement){
        Point point = Point.measurement(measurement)
                .addTag("transationId", event.getTransationId())
                .addTag("argName", event.getArgName())
                .addField("argValue", event.getArgValue())
                .time(event.getTime().toEpochMilli(), WritePrecision.MS);
        return point;

    }


    @PostMapping("/insert")
    public void insert() throws InterruptedException {
        Event event = new Event();
        event.setTime(Instant.now());
        event.setTransationId("asasd11");
        event.setArgName("argName11");
        event.setArgValue(99765d);
        Point asProcessCompleteEvent = insert(event, "ASProcessCompleteEvent");
        InfluxClient.Client.insert(event,"ASProcessCompleteEvent");
    }

    @PostMapping("/query")
    public void query() throws InterruptedException {

        QueryDataParam queryDataParam = new QueryDataParam();
        queryDataParam.setBucket("qgs-bucket");
        queryDataParam.setRange(new Range(getDate().toInstant(),getDateAfter().toInstant()));
        queryDataParam.setMeasurement("ASDASD");
        queryDataParam.setTag(new Tag("argName","1233"));
        queryDataParam.setDropedTagName("transationId");
        queryDataParam.setPageInfo(new PageInfo(1,100));

        List<FluxTable> tables = InfluxClient.Client.query(queryDataParam);
        //        List<FluxTable> tables = queryApi.query(flux);
        for (FluxTable fluxTable : tables) {
            List<FluxRecord> records = fluxTable.getRecords();
            for (FluxRecord fluxRecord : records) {
                Object value = fluxRecord.getValueByKey("_value");
                System.out.println("time: "+fluxRecord.getTime() +"   key:"+fluxRecord.getField()+"   value: " + fluxRecord.getValueByKey("_value")+"   measurement: " + fluxRecord.getMeasurement());

            }
        }

        System.out.println();
    }


}
